<?php

/* ----------------------------------------------------------------------
  class name: tabsheets
  class version: 1.0
  date: 2007-10-31
  ------------------------------------------------------------------------------
  author: grum at grum.dnsalias.com
  << May the Little SpaceFrog be with you >>
  ------------------------------------------------------------------------------

  this class provides base functions to manage tabsheet
  assuming that pwg templates and function exists
    - constructor tabsheets($name)
    - (public) function add($name, $caption, $url, $selected = false)
    - (public) function delete($name)
    - (public) function select($name)
    - (public) function make_tabsheets()
   ---------------------------------------------------------------------- */
class tabsheets
{
  var $sheets;
  var $name;

  /*
    $name is the tabsheet's name inside the template .tpl file 
  */
  function tabsheets($name='TABSHEET')
  {
    $sheets=array();
    $this->name=$name;
  }

  /*
     add a tab
     $caption is translated later by l10n function, so don't assign 
     a translated name
  */
  function add($name, $caption, $url, $selected = false)
  {
  if(!isset($this->sheets[$name]))
    {
      $this->sheets[$name] = array('caption' => $caption, 
                                   'url' => $url, 
                                   'selected' => $selected);
      return(true);
    }
    return(false);
  }

  /*
     remove a tab
  */
  function delete($name)
  {
  if(isset($this->sheets[$name]))
    {
      array_splice($this->sheets, $name, 1);
      return(true);
    }
    return(false);
  }

  /*
     select a tab to be active
  */
  function select($name)
  {
     foreach($this->sheets as $key => $val)
     {
        if($name==$key)
        {
           $this->sheets[$key]['selected']=true;
        }
        else
        {
           $this->sheets[$key]['selected']=false;
        }
     }
  }

  /*
    make tabsheet and apply it to the template

    $pages is an array of sheet
        $pages = array
    (
        'tab1' => array
         (
          'caption' => 'tab_caption'),
          'url' => 'tab_url',
          'selected' => 1 
         ),
        'tab2' => array
         (
          'caption' => 'tab_caption'),
          'url' => 'tab_url',
          'selected' => 0
         )
        )
  */
  function make_tabsheets()
  {
    global $template;

    if (count($this->sheets) > 0)
    {
      $template->set_filename('tabsheet', 'admin/tabsheet.tpl');

      foreach ($this->sheets as $tab_name => $tab)
      {
        $template->assign_block_vars
        (
          'tab',
          array
          (
              'CLASSNAME' => ($tab['selected'] ? 'selected_tab' : 'normal_tab'),
              'URL' => $tab['url'],
              'CAPTION' => l10n($tab['caption'])
          )
        );

        if ($tab['selected'])
        {
          $template->assign_vars(
              array('TABSHEET_TITLE' => '['.l10n($tab['caption']).']'));
        }
      }
      $template->assign_var_from_handle($this->name, 'tabsheet');
    }
  }

}//end class tabsheets


?>